package com.xydl.cac.service.impl;

import com.xydl.cac.entity.IcdTransform;
import com.xydl.cac.exception.BusinessException;
import com.xydl.cac.repository.IcdTransformRepository;
import com.xydl.cac.service.IcdTransformService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;
import java.util.Optional;

@Service
@Slf4j
@Transactional(rollbackFor = Exception.class)
public class IcdTransformServiceImpl implements IcdTransformService {

    @Resource
    IcdTransformRepository transformRepository;

    @Override
    public IcdTransform addTransform(IcdTransform icdTransform) {
        icdTransform.setId(null);
        IcdTransform save = transformRepository.save(icdTransform);
        return save;
    }

    @Override
    public void deleteTransform(Integer id) throws Exception {
        Optional<IcdTransform> byId = transformRepository.findById(id);
        if (!byId.isPresent()) {
            throw new BusinessException("未找到该记录!");
        }
        transformRepository.deleteById(id);
    }

    @Override
    public void clearTransform() {
        transformRepository.deleteAll();
    }

    @Override
    public List<IcdTransform> listTransform() {
        return transformRepository.findAll();
    }

}
